#include <avr/io.h>
#include <inttypes.h>
#include <util/delay.h>
#include <stdio.h> 
#include <motelib/system.h>
#include <motelib/timer.h>
#include <motelib/sensor.h>
#include <motelib/actor.h>
#include <motelib/uart.h>
#include <motelib/radio.h> 

Timer t;
uint8_t c;

int button_is_pressed1();
int button_is_pressed2();
int button_is_pressed3();
int button_is_pressed4();

int button_is_pressed1()
{
        return bit_is_clear(PINC, PINC0);
}
int button_is_pressed2()
{
        return bit_is_clear(PINC, PINC1);
}
int button_is_pressed3()
{
        return bit_is_clear(PINC, PINC2);
}
int button_is_pressed4()
{
        return bit_is_clear(PINC, PINC3);
}

void check(uint16_t value) {
       
	  if (button_is_pressed1())
      {
      		c=1;
           	printf("Q\n");
           	radioRequestTx(222, 99, &c, sizeof(c), NULL);
      }
      else if(button_is_pressed2())
      {
      		c=2;
      		printf("W\n");
      		radioRequestTx(222, 99, &c, sizeof(c), NULL);
      }
      else if(button_is_pressed3())
      {
      		c=3;
      		printf("E\n");
      		radioRequestTx(222, 99, &c, sizeof(c), NULL);
      }
      else if(button_is_pressed4())
      {
      		c=4;
      		printf("R\n");
      		radioRequestTx(222, 99, &c, sizeof(c), NULL);
      }
}

void boot()
{
		DDRC   &= ~(1 << PINC0);
		DDRC   &= ~(1 << PINC1);
		DDRC   &= ~(1 << PINC2);
		DDRC   &= ~(1 << PINC3);
    	PORTC  |= (1 << PINC0);
    	PORTC  |= (1 << PINC1);
    	PORTC  |= (1 << PINC2);
    	PORTC  |= (1 << PINC3); 
        e
		timerCreate(&t);
  		timerStart(&t, TIMER_PERIODIC, 150, check);
        
}

