#include <stdio.h>
#include <motelib/uart.h> 
#include <motelib/sensor.h> 
#include <motelib/actor.h> 
#include <motelib/radio.h> 
#include <motelib/system.h>
#include <motelib/timer.h>
#include <motelib/led.h>
#include <motelib/button.h>
#include <util/delay.h>

Timer t,t2,t3,t4,t5;

int cali = 506, previousx = 0, previousy = 0;
int16_t ansx = 0,ansy = 0;
bool statem3 = false;
void readAcceX(Timer *t);
void readAcceY(Timer *t);
void readDoneX(int16_t val);
//	timerStart(&t, TIMER_ONESHOT, 10, readAcceX);

/*	if(ansy > 0)
void readDoneY(int16_t val);
void send(Timer *t);

void handler(ButtonStatus s) 
{ 
 	if (s == BUTTON_PRESSED) 
	{
		int16_t temp = 1;
		radioRequestTx(222,1,&temp,2,NULL);	
		ledToggle(0);
	}	
 	if (s == BUTTON_RELEASED) 
	{
		int16_t temp = 0;
		radioRequestTx(222,1,&temp,2,NULL);	
		ledToggle(0);
	}
} 

void handler2(ButtonStatus s) 
{ 
 	if (s == BUTTON_PRESSED) 
	{
		int16_t temp = 1;
		radioRequestTx(222,2,&temp,2,NULL);	
		ledToggle(2);
	}	
 	if (s == BUTTON_RELEASED) 
	{
		int16_t temp = 0;
		radioRequestTx(222,2,&temp,2,NULL);	
		ledToggle(2);
	}
} 

void handler3(ButtonStatus s) 
{ 
 	if (s == BUTTON_PRESSED) 
	{
		int16_t temp = 1;
		radioRequestTx(222,3,&temp,2,NULL);	
		statem3 = true;
		ledToggle(4);
	}	
 	if (s == BUTTON_RELEASED) 
	{
		int16_t temp = 0;
		radioRequestTx(222,3,&temp,2,NULL);	
		statem3 = false;
		ledToggle(4);
	}
}

void fired(Timer *t)
{
	int x = 10;
	radioRequestTx(222,4,&x,2,NULL);
}
void boot()
{
	uartEnable(true,true); 
//	InitButton();
	buttonSetHandler(handler,handler2,handler3);
    timerCreate(&t);
    timerCreate(&t2);
    timerCreate(&t3);
    timerCreate(&t4);
    timerCreate(&t5);
//    timerCreate(&t6);
	timerStart(&t, TIMER_ONESHOT, 10, readAcceX);  
//	timerStart(&t, TIMER_PERIODIC, 1, fired);  
//	timerStart(&t2, TIMER_PERIODIC, 10, readAcceY);
//	timerStart(&t2, TIMER_PERIODIC, 10, send); 
}

void sendx(Timer *t)
{
	//printf("\nx:%d %d",ansx,ansy);
	if(!statem3)
	{
		//int16_t ansx2 = -ansx;		
		if(ansx != 0)
		{
			int16_t x;
			if(ansx < 0)
			{			
				x = -3;
				ansx++;
				//printf("\n%d",ansx);
			}
			else
			{
				x = 3;
				ansx--;
			}
			radioRequestTx(222,4,&x,2,NULL);							
		}
		else
		{
//			printf("ttt");
			timerStop(&t2);
			timerStart(&t3, TIMER_ONESHOT, 10, readAcceY);  
		}
	}
}

void sendy(Timer *t)
{
//	printf("\ny:%d %d",ansx,ansy);
	if(!statem3)
	{
		if(ansy != 0)
		{
			int16_t y;
			if(ansy < 0)
			{			
				y = -3;
				ansy++;
			}
			else
			{
				y = 3;
				ansy--;
			}
			radioRequestTx(222,5,&y,2,NULL);	
		}	
		else
		{
//			printf("yyy");
			timerStop(&t4);
			timerStart(&t, TIMER_ONESHOT, 10, readAcceX);  
		}
	}
	else
	{
		int16_t tempans = -ansy;
		radioRequestTx(222,6,&tempans,2,NULL);	
	}
}
void readAcceX(Timer *t) 
{
//	actorSetState(ACTOR_0, 1); 
	sensorRequestAnalog(SENSOR_1, readDoneX); 
}

void readDoneX(int16_t val)
{
//	printf("d");	
	int16_t len = 10,mlen = -10;
	int16_t mx = val-cali;
	int16_t dm = mx - previousx;
	ansx = mx/5;//(int16_t)(dm/2); 
	printf("\nx:%d",ansx);
	if(dm <= 10 && dm >= -10)
		ansx = 0;
	if(!statem3)
		radioRequestTx(222,4,&ansx,2,NULL);	
	/*if(ansx < 0 && mx > 0)
	{
		//printf("%d\n",(int)ansx);
	}
	else if (ansx > 0 && mx < 0)
	{
		//printf("%d\n",(int)ansx);
	}
	else 
		ansx = 0;*/

	previousx = mx;
	/*if(ansx > 0)
		for(int i = 0;i < ansx;i++)
			radioRequestTx(222,4,&len,2,NULL);	
	else if(ansx < 0)
		for(int i = 0;i < -ansx;i++)
			radioRequestTx(222,4,&mlen,2,NULL);	*/
	timerStart(&t2, TIMER_ONESHOT, 10, readAcceY);  

	//printf("\nd:%d",100/ansx);
	/*if(ansx == 0)
		timerStart(&t2, TIMER_ONESHOT, 10, readAcceY);  
	else
	{		
		int send = 10/ansx;
	//	timerStop(&t);
		if(send == 0 )
			send = 1;
		if(send < 0)	
			timerStart(&t2, TIMER_PERIODIC, -send, sendx);	
		else if(send > 0)
			timerStart(&t2, TIMER_PERIODIC, send, sendx);
	//	actorSetState(ACTOR_0, 0); 
	}*/
}

void readAcceY(Timer *t) 
{
	sensorRequestAnalog(SENSOR_2, readDoneY); 
}

void readDoneY(int16_t val)
{
	int16_t len = 10,mlen = -10;
	int16_t my = val-cali;
	int16_t dm = my - previousy;
	ansy = my/5;//(int16_t)(dm/2);
//	printf("\ny:%d",ansy);
//	printf("\n%d %d",ansx,ansy);

	if(dm <= 10 && dm >= -10)
		ansy = 0;
	if(!statem3)
		radioRequestTx(222,5,&ansy,2,NULL);			
	else
	{
		int16_t tempans = -ansy;
		radioRequestTx(222,6,&tempans,2,NULL);	
	}
	/*if(ansy > 0 && my > 0)
	{
//	timerStart(&t, TIMER_ONESHOT, 10, readAcceX);

/*	if(ansy > 0)
		printf("%d\n",(int)ansy);
	}
	else if (ansy < 0 && my < 0)
	{
		printf("%d\n",(int)ansy);
	}
	else 
		ansy = 0;*/
	previousy = my;
//	timerStop(&t2);
//	timerStart(&t, TIMER_ONESHOT, 10, ChkButton);  
//	timerStart(&t, TIMER_ONESHOT, 10, readAcceX);

/*	if(ansy > 0)
		for(int i = 0;i < ansy;i++)		
			radioRequestTx(222,5,&len,2,NULL);			
	else if(ansy < 0)
		for(int i = 0;i < -ansx;i++)
			radioRequestTx(222,5,&mlen,2,NULL);	*/
	timerStart(&t, TIMER_ONESHOT, 10, readAcceX);  

/*	if(ansy == 0)
		timerStart(&t, TIMER_ONESHOT, 10, readAcceX);  
	else
	{
		int send = 10/ansy;
		printf("\n%d",send);
	//	printf("\nf:%d",100/ansy);
		if(send == 1)
			send = 5;
		if(send < 0)
			timerStart(&t4, TIMER_PERIODIC, -send, sendy);
		else if(send > 0)
			timerStart(&t4, TIMER_PERIODIC, send, sendy);	
	}*/
} 
